(define-library (otus datetime)
   (version 1.0)
   (license MIT/LGPL3)
   (keywords (otus ol date time datetime unian gregorian))
   (description "
      Otus-Lisp date-time library")

   (export
      epoch
      date
      time
      datetime)

   (import
      (scheme core)
      (srfi 11)
      (owl math))

(begin
   ; number of seconds that have elapsed since January 1, 1970 at midnight UTC time
   ;  minus the leap seconds
   (define (epoch)
      (car (syscall 96)))

   ; первый год, начался в субботу, не високосный

   (define // div)
   (define (ne? a b) (not (eq? a b)))

   ; 
   (define minute-in-sec 60)
   (define hour-in-sec 3600) ; 60*60
   (define day-in-sec 86400) ; 60*60*24
   (define year-in-sec [31536000 31622400]) ; non-leap, leap

   (define (days-before-year year)
      (define y (-- year))
      (+ (* y 365) (div y 4) (div y -100) (div y 400)))
   (define days-in-month
      [0 31 28 31 30 31 30 31 31 30 31 30 31])
   (define days-before-month
      [0 31 59 90 120 151 181 212 243 273 304 334 365])

   (define dby400 (days-before-year 401)) ; 145731
   (define dby100 (days-before-year 101))
   (define dby4   (days-before-year   5))

   ; convert days sinse 1 Jan 0001 AD to gregorian date
   (define (date days)
      (define rest (- days 1))
      (let*((n400 rest (divmod rest dby400))
            (n100 rest (divmod rest dby100))
            (n4   rest (divmod rest dby4))
            (n1   days (divmod rest 365))
            (year (+ (* n400 400)
                     (* n100 100)
                     (* n4 4)
                        n1   1))) ; 1 for 0001-01-01 AD

         (if (or (eq? n1 4) (eq? n100 4)) ; очень спорное условие, todo: проверить!
            [31 12 (- year 1)]
         else
            (define leapyear (and (eq? n1 3) ; 4-1
                                  (or (ne? n4 24) ; 100/4-1
                                      (eq? n100 3)))) ; 4-1
            (define month (>> (+ days 50) 5))
            (define preceding (+ (ref days-before-month month) (if (and (less? 2 month) leapyear) 1 0)))
            (if (less? days preceding)
               (let ((month (-- month))
                     (preceding (- preceding (ref days-in-month month) (if (and (eq? month 2) leapyear) 1 0))))
                  [(- days preceding -1) month year])
               [(- days preceding -1) month year]))))

   (define time #f)
   (define datetime #f)
))
